import java.util.ArrayList;

public class Spieler {
  private String name;
  private ArrayList<Item> items;
  
  public Spieler(String name) {
    this.name = name;
    this.items = new ArrayList<Item>();
    this.items.add(new Pilz());
  }
  
  public void handeln(Haendler h, EinUndAusgabe io) {
    Item geben = this.auswaehlen(io);
    if (geben != null) {
      this.items.remove(geben);
      this.items.addAll(h.handel(geben));
    }
  }
  
  private Item auswaehlen(EinUndAusgabe io) {
    io.ausgeben("Welches Item wollen Sie tauschen?");
    io.ausgeben("\n (0) abbrechen" );
    for(int i = 0; i < this.items.size(); i++) {
      io.ausgeben("\n (" + (i + 1) + ") " + this.items.get(i) );
    }
    io.ausgeben("  : ");
    int ein = io.leseInteger();
    if (ein < 1 || ein > this.items.size()) {
      return null;
    }
    Item ergebnis = this.items.get(ein - 1);
    return ergebnis;
  }
  
  public String getName() {
    return this.name;
  }
  
  @Override
  public String toString() {
    return this.name + ": " + this.items;
  }
}
