public class Linie { // implements Cloneable{
    private Punkt start;
    private Punkt ende;

    public Linie(Punkt start, Punkt ende) {
        this.start = start;
        this.ende = ende;
    }

    public Linie(Linie other) {  // tiefe Kopie
        if (other.getStart() != null) {
            this.start = other.getStart().clone();
        }
        if (other.getEnde() != null) {
            this.ende = other.getEnde().clone();  
        }
    }
    
    // public Linie(Linie other) { // flache Kopie
        // this.start = other.getStart();
        // this.ende = other.getEnde();
    // }

    public Punkt getStart() {
        return start;
    }

    public void setStart(Punkt start) {
        this.start = start;
    }

    public Punkt getEnde() {
        return ende;
    }

    public void setEnde(Punkt ende) {
        this.ende = ende;
    }

    @Override
    public String toString(){
        return "["+this.start+"->"+this.ende+"]";
    }

    @Override
    public boolean equals(Object obj) {
        if (obj == null ||!(obj instanceof Linie)) {
            return false;
        }
        Linie other = (Linie) obj;
        if (this.ende == null) {
            if (other.getEnde() != null) {
                return false;
            }
        } else {
            if (!this.ende.equals(other.getEnde())) {
                return false;
            }
        }
        if (this.start == null) {
            if (other.getStart() != null) {
                return false;
            }
        } else {
            if (!this.start.equals(other.getStart())) {
                return false;
            }
        }
        return true;
    }

    @Override
    public Linie clone(){
        Punkt tmp1 = null;
        Punkt tmp2 = null;
        if (this.start != null){
            tmp1 = this.start.clone();
        }
        if (this.ende != null){
            tmp2 = this.ende.clone();
        }        
        return new Linie(tmp1, tmp2);
    }

    /* nutzt Methode clone() von Object,
     * schafft aber nut flache Kopie, hier nicht betrachtet

    @Override
    public Linie clone(){
    Linie ergebnis = null;
    try {
    return (Linie)super.clone();
    } catch (CloneNotSupportedException e) {
    // TODO Auto-generated catch block
    e.printStackTrace();
    }
    return ergebnis;
    }
     */

}
